// +------------------------------------------------------------------+
// |             ____ _               _        __  __ _  __           |
// |            / ___| |__   ___  ___| | __   |  \/  | |/ /           |
// |           | |   | '_ \ / _ \/ __| |/ /   | |\/| | ' /            |
// |           | |___| | | |  __/ (__|   <    | |  | | . \            |
// |            \____|_| |_|\___|\___|_|\_\___|_|  |_|_|\_\           |
// |                                                                  |
// | Copyright Mathias Kettner 2012             mk@mathias-kettner.de |
// +------------------------------------------------------------------+
//
// This file is part of Check_MK.
// The official homepage is at http://mathias-kettner.de/check_mk.
//
// check_mk is free software;  you can redistribute it and/or modify it
// under the  terms of the  GNU General Public License  as published by
// the Free Software Foundation in version 2.  check_mk is  distributed
// in the hope that it will be useful, but WITHOUT ANY WARRANTY;  with-
// out even the implied warranty of  MERCHANTABILITY  or  FITNESS FOR A
// PARTICULAR PURPOSE. See the  GNU General Public License for more de-
// ails.  You should have  received  a copy of the  GNU  General Public
// License along with GNU Make; see the file  COPYING.  If  not,  write
// to the Free Software Foundation, Inc., 51 Franklin St,  Fifth Floor,
// Boston, MA 02110-1301 USA.

#ifndef StringColumnFilter_h
#define StringColumnFilter_h

#include "config.h"

#include <sys/types.h>
#ifdef HAVE_ICU
#include <unicode/regex.h>
#else
#include <regex.h>
#endif
#include <string>

using namespace std;

#include "Filter.h"
class StringColumn;

class StringColumnFilter : public Filter
{
    StringColumn *_column;
    string _ref_string;
    int _opid;
    bool _negate;
#ifdef HAVE_ICU
    icu::RegexMatcher *_regex_matcher;
#else
    regex_t *_regex;
#endif

public:
    StringColumnFilter(StringColumn *_column, int opid, char *value);
    ~StringColumnFilter();
    bool accepts(void *data);
    void *indexFilter(const char *column);
};


#endif // StringColumnFilter_h

